﻿// ==UserScript==
// @name         Grab The Product
// @author       Xian Hong
// @namespace    http://www.cnblogs.com/xianhong/
// @description  
// @include      http://www.tmall.com/
// ==/UserScript==



function withjQuery(callback, safe) {
    if (typeof (jQuery) == "undefined") {
        var script = document.createElement("script");
        script.type = "text/javascript";
        script.src = "https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js";

        if (safe) {
            var cb = document.createElement("script");
            cb.type = "text/javascript";
            cb.textContent = "jQuery.noConflict();(" + callback.toString() + ")(jQuery);";
            script.addEventListener('load', function () {
                document.head.appendChild(cb);
            });
        }
        else {
            var dollar = undefined;
            if (typeof ($) != "undefined") dollar = $;
            script.addEventListener('load', function () {
                jQuery.noConflict();
                $ = dollar;
                callback(jQuery);
            });
        }
        document.head.appendChild(script);
    } else {
        callback(jQuery);
    }
};

withjQuery(function ($) {
    var __status = 0;
    /*pub-1|2013-06-17 01:42:14*/
    KISSY.add("main/hypX", function (a, e, d, c) {

        function b(g) {
            var f = this;
            f.config = a.merge(b.Config, g);
            f._init();
        }
        b.Config = {
            cids: [1, 2],
            bladeInterval: 1000,
            passRate: 1,
            loopInterval: 5000,
            requestTimeout: 3,
            selectInterval: 150,
            maxScratch: 4,
            scratchInterval: 100,
            failTypeArr: [0, 0, 1, 1, 1],
            inspireRate: 0.25,
            retryNum: 3
        };
        a.augment(b, a.EventTarget, {
            _init: function () {
                var f = this;
                f.modelX = new e(f.config);
                f.viewX = new d(f.config);
                f.viewX.bindmodelX(f.modelX);
                f.viewX.init();
                f._catchError();

            },
            _catchError: function () {
                window.onerror = function (g, f) {
                    c.log(g + " @ " + f);
                    return true
                }
            }
        });
        return b
    }, {
        requires: ["./modelX", "./viewX", "./utilX"]
    }); /*pub-1|2013-06-17 01:42:15*/
    KISSY.add("main/modelX", function (g, j, b, e) {
        var f = !!(~document.location.host.indexOf(".net"));
        var a = f ? "earth.daily.tmall.net" : "earth.promotion.taobao.com";
        var i = {
            loop: "http://" + a + "/earth/query.do",
            blade: "http://" + a + "/earth/blade.do"
        };
        var k = undefined;
        var h;
        var d;

        function c(m) {
            var l = this;
            l.config = g.merge(c.Config, m);
            if (!l.config.cids || l.config.cids.length < 1) {
                return
            }
        }
        c.Config = {
            cids: [7, 8],
            loopInterval: 5000,
            requestTimeout: 3
        };
        g.augment(c, g.EventTarget, {
            startLoop: function (m, n) {
                var l = this;
                d && d.cancel();
                if (!m) {
                    l._loop()
                }
                d = g.later(function () {
                    l._loop()
                }, n || l.config.loopInterval, true)
            },
            stopLoop: function () {
                d && d.cancel()
            },
            blade: function (o, n, l) {
                var m = this;
                if (!h) {
                    return
                }
                //return; ////
                m.startLoop(true);
                m.jsonp(i.blade, {
                    cids: m.config.cids.join(","),
                    nick: k && k.nick,
                    tid: h.tid,
                    id: o,
                    ua: e.getUAToken(),
                    _input_charset: "UTF-8"
                }, function (p) {
                    n && n.call(m, p);
                    h = p || h;
                    if (!p || p.code === 9) {
                        return
                    }
                    k = k || {};
                    k.isLogin = !p.code;
                    k.nick = p.nick || k.nick
                }, function (p, q) {
                    l && l.call(m, q)
                })
            },
            jsonp: function (n, p, o, l) {
                var m = this;
                g.ajax({
                    type: "get",
                    url: n,
                    data: p,
                    dataType: "jsonp",
                    scriptCharset: "gbk",
                    timeout: m.config.requestTimeout,
                    success: o,
                    error: l
                })
            },
            mergeConfig: function (m) {
                var l = this;
                return l.config = g.merge(l.config, m)
            },
            loginStatusReady: function (l) {
                if (k === undefined) {
                    TB && TB.Global && TB.Global.loginStatusReady(function (m) {
                        k = m;
                        l && l.call(self, k.isLogin)
                    })
                } else {
                    l && l.call(self, k.isLogin)
                }
            },
            _loop: function () {
                var l = this;
                l.jsonp(i.loop, {
                    cids: l.config.cids.join(","),
                    nick: k && k.nick,
                    _input_charset: "UTF-8"
                }, function (m) {
                    l.fire("loopSuc", {
                        result: m
                    });
                    h = m || h
                }, function (m, n) {
                    l.fire("loopErr", {
                        textStatus: n
                    })
                })
            }
        });
        return c
    }, {
        requires: ["event", "ajax", "./ua-helperX"]
    }); /*pub-1|2013-06-17 01:46:39*/
    KISSY.add("main/viewX", function (f, n, m, i, j, b, h, l) {
        var e = 6 === h.ie;
        var c = 0;
        var k = null;
        var g = 0;
        var d = false;

        function a(p) {
            var o = this;
            o.config = f.merge(a.Config, p)
        }
        a.Config = {
            selectInterval: 500
        };
        f.augment(a, f.EventTarget, {
            mergeConfig: function (p) {
                var o = this;
                return o.config = f.merge(o.config, p)
            },
            init: function () {
                var o = this;
                if (!o.modelX) {
                    return
                }
                o.halfYear = f.one("#J_HalfYear");
                if (!o.halfYear) {
                    return
                }
                o.hypItems = o.halfYear.all(".j_HYPItem");
                o.curItem = o.hypItems && f.one(o.hypItems[0]);
                o._guideAnim();
                o._bindSelectItem();
                o._bindBlade();
                o._secondaryFunc()
            },
            bindmodelX: function (p) {
                var o = this;
                o.modelX = p;
                o.modelX.on("loopSuc", function (q) {
                    l.log("****************  loop ****************");
                    o._update(q.result, "loop")
                });
                o.modelX.on("loopErr", function (q) {
                    l.log("轮询接口发生异常");
                    o._feedbackErr()
                })
            },
            _bindSelectItem: function () {
                var o = this;
                if (!o.halfYear) {
                    return
                }
                o.halfYear.all(".j_HYPItem").on("mouseenter mousemove touchmove", function (q) {
                    var p = f.one(q.currentTarget);
                    if (p.data("data-timer")) {
                        return
                    }
                    var r = f.later(function () {
                        o.curItem = p
                    }, o.config.selectInterval);
                    p.data("data-timer", r)
                });
                o.halfYear.all(".j_HYPItem").on("mouseleave touchend", function (q) {
                    var p = f.one(q.currentTarget);
                    var r = p.data("data-timer");
                    r && r.cancel();
                    p.removeData("data-timer");
                    k = null;
                    g = 0
                })
            },
            _bindBlade: function () {
                var o = this;
                if (!o.halfYear) {
                    return
                }

                o._limitBlade = f.throttle(o._blade, o.config.bladeInterval);
                o._limitScratch = f.throttle(o._scratchAnim, o.config.scratchInterval);


                var funB = function (y, r, x1, y1) {

                    var timer = $(".countDownSecond").eq(0);
                    var ht = timer.html();

                    var timer2 = $(".countDownSecond").eq(1);
                    var ht2 = timer2.html();
                    if (ht != "开始" && ht != "" && ht2 != "开始" && ht2 != "") return;

                    console.log("------------------id:" + y + "--------------------");
                    var cx = l.locationToDegree(x1, y1);

                    o._limitScratch(r, cx);

                    o._blade(y, function (z) {
                        o._update(z, "blade")
                    }, function (z, A) {
                        l.log("砍价接口发生异常" + A);
                        o._feedbackErr(r)
                    });
                    console.log("------------------id:" + y + " end --------------------");
                };


                var loopx = function () {
                    var op = f.all(".j_HYPItem");

                    var ol1 = op.item(0);
                    var ol2 = op.item(1);
                    var y1 = ol1.attr("data-id");
                    var y2 = ol2.attr("data-id");

                    var xt = setTimeout(function () {
                        clearTimeout(xt);
                        funB(y1, ol1, 17, 20);

                    }, 250);

                    var yt = setTimeout(function () {
                        clearTimeout(yt);
                        funB(y2, ol2, 17, 30);
                    }, 500);
                    $(".j_HYPFeedback").hide();
                    setTimeout(loopx, 500);
                };

                loopx();

                o.halfYear.delegate("mouseenter", ".j_HYPScratchBlock", function (s) {
                    console.log('****************** mouseenter *******************');
                    var p = f.one(s.currentTarget);
                    var r = p.parent(".j_HYPItem");
                    if (!r) {
                        return
                    }
                    var q = r.one(".j_HYPCountDown");
                    if (!q) {
                        return
                    }
                    var t = q.data("data-timer");
                    if (t) {
                        return
                    }
                    if (!o.curItem || o.curItem.getDOMNode() != r.getDOMNode()) {
                        return
                    }
                    p.data("data-location", {
                        pageX: s.pageX,
                        pageY: s.pageY
                    })


                });
                o.halfYear.delegate("mouseleave", ".j_HYPScratchBlock", function (s) {
                    console.log('****************** mouseleave *******************');
                    var p = f.one(s.currentTarget);
                    var r = p.parent(".j_HYPItem");
                    if (!r) {
                        console.log('!r 成立');
                        return
                    }
                    var q = r.one(".j_HYPCountDown");
                    if (!q) {
                        console.log('!q 成立');
                        return
                    }
                    var t = q.data("data-timer");
                    if (t) {
                        console.log('t 成立');
                        return
                    }
                    if (!o.curItem || o.curItem.getDOMNode() != r.getDOMNode()) {
                        console.log('!o.curItem || o.curItem.getDOMNode() != r.getDOMNode() 成立');
                        return
                    }
                    o._loginReady(function () {
                        var v = p.data("data-location");
                        if (!v) {
                            console.log('!v 成立');
                            return
                        }


                        p.removeData(v);
                        var u = v.pageY - s.pageY;
                        var w = s.pageX - v.pageX;
                        console.log("******************* u w **********************");
                        console.log(u);
                        console.log(w);
                        if (Math.abs(w) < 10 && Math.abs(u) < 70 || Math.abs(u) < 10 && Math.abs(w) < 80) {
                            return
                        }
                        var x = l.locationToDegree(u, w);
                        o._limitScratch(r, x);
                        if (l.randomInt(0, 100) / 100 > o.config.passRate) {
                            return
                        }
                        var y = r.attr("data-id");
                        o._limitBlade(y, function (z) {
                            o._update(z, "blade")
                        }, function (z, A) {
                            l.log("砍价接口发生异常" + A);
                            o._feedbackErr(r)
                        })
                    })
                });
                o.halfYear.on("touchmove", function (s) {
                    var p = o._inWhitchItemScratchArea(s.pageX, s.pageY);
                    if (!p) {
                        return
                    }
                    var r = p.parent(".j_HYPItem");
                    if (!r) {
                        return
                    }
                    var q = r.one(".j_HYPCountDown");
                    if (!q) {
                        return
                    }
                    var t = q.data("data-timer");
                    if (t) {
                        return
                    }
                    if (!o.curItem || o.curItem.getDOMNode() != r.getDOMNode()) {
                        return
                    }
                    o._loginReady(function () {
                        k = k || {
                            pageX: s.pageX,
                            pageY: s.pageY
                        };
                        var u = k.pageY - s.pageY;
                        var v = s.pageX - k.pageX;
                        if (Math.sqrt(u * u + v * v) < 30) {
                            return
                        }
                        if (Math.abs(v) < 10 && Math.abs(u) < 70 || Math.abs(u) < 10 && Math.abs(v) < 80) {
                            return
                        }
                        var w = l.locationToDegree(u, v);
                        if (Math.sqrt(u * u + v * v) > 30 && Math.abs(w - o.beginDegree) < 10) {
                            return
                        }
                        o._limitScratch(r, w);
                        g = l.locationToDegree(u, v);
                        k = {
                            pageX: s.pageX,
                            pageY: s.pageY
                        };
                        if (l.randomInt(0, 100) / 100 > o.config.passRate) {
                            return
                        }
                        var x = r.attr("data-id");
                        o._limitBlade(x, function (y) {
                            o._update(y, "blade")
                        }, function (y, z) {
                            l.log("砍价接口发生异常" + z);
                            o._feedbackErr(r)
                        })
                    })
                });
                f.one("body").on("touchmove", function (p) {
                    if (p.pageY < 400) {
                        p.halt()
                    }
                })
            },
            _loginReady: function (q) {
                var o = this;
                if (!o.modelX) {
                    return
                }
                var p = false;
                o.modelX.loginStatusReady(function (r) {
                    p = true;
                    if (r) {
                        q && q.call()
                    } else {
                        o._showMiniLogin(false)
                    }
                });
                f.later(function () {
                    if (p) {
                        return
                    }
                    o._showMiniLogin(true)
                }, o.config.requestTimeout)
            },
            _showMiniLogin: function (o) {
                f.use("tml/minilogin", function (q, p) {
                    if (d) {
                        return
                    }
                    p.show({
                        check: o,
                        needRedirect: true
                    });
                    d = true
                })
            },
            _blade: function (r, q, o) {
                var p = this;

                if (!p.modelX) {
                    console.log("!p.modelX");
                    return
                }

                p.modelX.blade(r, q, o)
            },
            _update: function (w, s) {
                var u = this;
                if (!w || w.status == 1111) {
                    l.log("接口被限流了");
                    return
                }
                if (w.code !== 0 && w.code !== 1) {
                    l.log("接口产生错误");
                    u._feedbackErr();
                    return
                }
                l.log(w);
                for (var q = 0; q < u.hypItems.length; q++) {
                    if (!u.config.cids || !u.config.cids[q]) {
                        l.log("cids\u4e0d\u5b58\u5728\u6216cids[" + q + "]\u4e0d\u5b58\u5728");
                        continue
                    }
                    var p = w[u.config.cids[q]];
                    if (!p) {
                        l.log("cids[" + q + "]对应数据不存在");
                        continue
                    }
                    var t = u._getItem(q);
                    var r = p.p0,
                        v = p.c1,
                        o = p.n2;
                    u._updateItem(t, r, v, o, w.ts, s)
                }
            },
            _updateItem: function (t, u, q, p, s, r) {
                var o = this;
                if (!t || !q) {
                    return
                }
                l.log("---------- " + t.attr("data-id") + " -----------");
                switch (q.s) {
                    case -1:
                        __status = -1;
                        if (u && p) {
                            l.log("本时段大砍间隔");
                            if (p.st - u.et <= 3600 * 1000) {
                                l.log("本时段大砍小轮间隔");
                                o._feedback(t, u, q, r);
                                o._stopLotteryAnim(t);
                                l.log("砍价接口发生异常");
                                o._updateBlood(t, p);
                                o._updateItemInfo(t, p);
                                o._setCountDown(t, p ? (p.st - s) : 0);
                                o._updateItemStatus(t, "prenotify")
                            } else {
                                l.log("今日中场休息时间");
                                o._updateItemInfo(t, {
                                    imu: "http://img03.taobaocdn.com/tps/i3/T1pHS1XuhfXXXCSD2S-270-230.png"
                                });
                                o._updateItemStatus(t, "end");
                                o.modelX.stopLoop()
                            }
                        } else {
                            if (!u) {
                                l.log("本时间段大砍未开始");
                                o._updateItemInfo(t, {
                                    imu: "http://img01.taobaocdn.com/tps/i1/T1LNy5XE4XXXXCSD2S-270-230.png"
                                })
                            } else {
                                if (!p) {
                                    l.log("大砍活动已结束");
                                    o._updateItemInfo(t, {
                                        imu: "http://img04.taobaocdn.com/tps/i4/T1eqOZXwFgXXXCSD2S-270-230.png"
                                    });
                                    o._updateItemStatus(t, "end");
                                    o.modelX.stopLoop()
                                }
                            }
                        }
                        o._stopRuleGuideAnim(t);
                        t.data("data-record", false);
                        t.data("data-isGuide", false);
                        t.data("data-fb", false);
                        break;
                    case 0:
                        __status = 0;
                        l.log("本轮商品未开始");
                        break;
                    case 1:
                        __status = 1;
                        l.log("本轮商品砍价中");
                        o._ruleGuideAnim(t);
                        o._updateBlood(t, q);
                        o._updateItemInfo(t, q);
                        o._updateItemStatus(t, "blade");
                        break;
                    case 2:
                        __status = 2;
                        l.log("本轮商品爆奖中,请稍后");
                        o._stopRuleGuideAnim(t);
                        o._updateBlood(t, q);
                        o._updateItemInfo(t, q);
                        o._lotteryAnim(t);
                        o._updateItemStatus(t, "lottery");
                        break;
                    case 3:
                        l.log("本轮商品已出结果");
                        o._stopRuleGuideAnim(t);
                        o._feedback(t, u, q, r);
                        o._stopLotteryAnim(t);
                        o._updateBlood(t, p);
                        o._updateItemInfo(t, p);
                        o._setCountDown(t, p.st - s);
                        o._updateItemStatus(t, "prenotify");
                        break;
                    case 4:
                        l.log("本轮商品已结束");
                        break;
                    default:
                        l.log("商品状态出错啦")
                }
                o._updateNotice(q, u);
                t.data("data-ci", q);
                r == "loop" && t.data("data-loopCi", q)
            },
            _updateItemInfo: function (r, o) {
                if (!r || !o) {
                    return
                }
                var q = r.one(".j_HYPItemInfo");
                var p = r.one(".j_HYPItemLogo");
                var s = r.attr("data-id");
                if (!s && !o.id || s != o.id) {
                    if (o.lgu) {
                        q.css({
                            backgroundImage: "url(" + o.lgu + ")"
                        }).fadeIn(0.3)
                    } else {
                        q.fadeOut(0.3)
                    }
                    p.css({
                        backgroundImage: "url(" + o.imu + ")"
                    }).fadeIn(0.3);
                    if (e) {
                        if (o.lgu) {
                            q.css({
                                background: "none",
                                filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + o.lgu + '", sizingMethod="crop"'
                            })
                        } else {
                            q.fadeOut(0.3)
                        }
                        p.css({
                            background: "none",
                            filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + o.imu + '", sizingMethod="crop"'
                        })
                    }
                    if (o.id && o.it) {
                        r.attr("data-id", o.id);
                        r.attr("data-it", o.it)
                    }
                }
            },
            _updateItemStatus: function (p, o) {
                if (!p || !o) {
                    return
                }
                p.one(".j_HYPItemStatus").attr("class", "j_HYPItemStatus hypItemStatus " + o + "Status")
            },
            _setCountDown: function (t, o) {
                var r = this;
                if (!r.hypItems || !t || !o || !r.modelX) {
                    return
                }
                var s = Math.round(o / 1000);
                if (s <= 0) {
                    return
                }
                var q = t.one(".j_HYPCountDown");
                if (!q) {
                    return
                }
                var p = q.one(".j_CountDownSecond");
                var u = q.data("data-timer");
                u && u.cancel();
                p.html(r._formatCountDown(s));
                u = f.later(function () {
                    if (s <= 1) {
                        q.hide();
                        u.cancel();
                        q.removeData("data-timer", u);
                        return
                    }
                    s--;
                    p.html(r._formatCountDown(s))
                }, 1000, true);
                q.data("data-timer", u);
                q.show()
            },
            _updateNotice: function (q, s) {
                var p = this;
                var r = f.one("#J_HYPNoticeCtn");
                if (!r) {
                    return
                }
                var o = r.data("data-at");
                if (q && q.winners && q.winners.length > 0 && q.at && (!o || q.at > o)) {
                    r.html(p._getWinnerList(q.winners, 20) + "\u83b7\u5f97\u4e86" + q.title);
                    r.data("data-at", q.at);
                    return
                }
                if (s && s.winners && s.winners.length > 0 && s.at && (!o || s.at > o)) {
                    r.html(p._getWinnerList(s.winners, 20) + "\u83b7\u5f97\u4e86" + s.title);
                    r.data("data-at", s.at)
                }
            },
            _updateBlood: function (C, t) {
                if (!C || !t) {
                    return
                }
                var u = t.op;
                var w = t.cp;
                var o = t.bp;
                if (o > w || w > u) {
                    return
                }
                var p = C.one(".j_HYPBloodValCon");
                var v = C.one(".j_HYPBloodVal");
                if (!p || !v) {
                    return
                }
                var q = p.width();
                var x = Math.round((w - o) / (u - o) * q);
                var r = -33;
                var B = x - q + r;
                v.stop();
                v.animate({
                    left: B
                }, 0.2, "easeOut");
                var s = C.one(".j_HYPPriceVal");
                if (!s) {
                    return
                }
                s.html(w / 100);
                var z = C.one(".j_HYPPriceTip");
                if (!z) {
                    return
                }
                var A = 262;
                var y = x - q + A;
                z.show();
                z.stop();
                z.animate({
                    left: y
                }, 0.2, "easeOut", false)
            },
            _feedback: function (w, s, y, t) {
                var x = this;
                if (!w || !y || !t) {
                    return
                }
                if (w.data("data-fb")) {
                    return
                }
                var q = y;
                var o = w.data("data-ci");
                var p = o && o.s;
                var v = w.data("data-loopCi");
                var r = v && v.s;
                l.log("feedback", "ci.s", y.s, "historyStatus", p, "historyLoopStatus", r);
                if (y.s == -1) {
                    q = s;
                    if (p == 1) {
                        l.log("\u672c\u8f6e\u8f6e\u7a7a");
                        x._popup("bye", {
                            container: w,
                            itemId: q.it,
                            autoClose: true
                        });
                        w.data("data-fb", true)
                    } else {
                        if (p == 2) {
                            l.log("很遗憾，你没中奖！");
                            x._popup("fail", {
                                autoClose: false,
                                container: w,
                                itemId: q.it,
                                winnerNum: q.winners ? q.winners.length : 0,
                                winners: x._getWinnerList(q.winners, 5),
                                failTypeArr: x.config.failTypeArr
                            });
                            w.data("data-fb", true);
                            return
                        }
                    }
                }
                if (y.s == 3 && (p == 2 || p == 1 || r == 2 || r == 1)) {
                    var u = q.winners && q.winners.join("\u3001");
                    l.log("本轮商品中奖用户为" + u);
                    if (u && q.winning) {
                        l.log("恭喜，你中奖啦");
                        x._popup("suc", {
                            autoClose: false,
                            container: w,
                            title: q.title,
                            price: q.bp / 100,
                            url: q.itu,
                            itemId: q.it
                        })
                    } else {
                        l.log("很遗憾，你没中奖！");
                        x._popup("fail", {
                            autoClose: false,
                            container: w,
                            itemId: q.it,
                            winnerNum: q.winners ? q.winners.length : 0,
                            winners: x._getWinnerList(q.winners, 5),
                            failTypeArr: x.config.failTypeArr
                        })
                    }
                    w.data("data-fb", true)
                }
            },
            _guideAnim: function () {
                var q = this;
                var p = f.one("#J_HalfYearGuide");
                if (!p) {
                    q.modelX.startLoop();
                    return
                }
                var o = p.one(".j_HYPSlogon");
                var s = p.one(".j_HYPBenefit");
                var r = p.one(".j_HYPGuideScratch");
                if (!o || !s || !r) {
                    return
                }
                if (h.ie < 10) {
                    o.css({
                        marginLeft: -500,
                        display: "block"
                    });
                    o.animate({
                        marginLeft: -265
                    }, 0.8, "bounceIn", function () {
                        s.css({
                            marginLeft: 600,
                            display: "block"
                        });
                        s.animate({
                            marginLeft: e ? -240 : -313
                        }, 0.8, "bounceIn")
                    })
                } else {
                    o.addClass("bounceInLeft").show();
                    f.later(function () {
                        o.removeClass("bounceInLeft");
                        s.addClass("bounceInRight").show();
                        f.later(function () {
                            s.removeClass("bounceInRight")
                        }, 2000)
                    }, 500)
                }
                f.later(function () {
                    r.css({
                        width: 0,
                        height: 0,
                        display: "block"
                    });
                    r.animate({
                        width: 652,
                        height: 436
                    }, 0.1, "easeIn", function () {
                        f.later(function () {
                            p.fadeOut(0.5, function () {
                                q.modelX.startLoop();
                                b.set("hyp_ng", true, 365)
                            })
                        }, 1000)
                    })
                }, 2500)
            },
            _popup: function (p, o) {
                f.use("main/feedback", function (r, q) {
                    q.popup(p, o)
                })
            },
            _ruleGuideAnim: function (q) {
                var p = this;
                if (!q) {
                    return
                }
                if (q.data("data-isGuide")) {
                    return
                }
                var o = f.later(function () {
                    p._guideMouse(q, function () {
                        p._scratchAnim(q, 225, "guide")
                    })
                }, 2000, true);
                q.data("data-guideTimer", o);
                q.data("data-isGuide", true)
            },
            _stopRuleGuideAnim: function (r) {
                if (!r) {
                    return
                }
                var o = r.data("data-guideTimer");
                o && o.cancel();
                r.removeData("data-guideTimer");
                var p = r.one(".j_HYPScratch").one(".j_HYPGuideMouse");
                p && p.hide();
                var q = r.one(".j_HYPRuleTip");
                q && q.fadeOut(0.3)
            },
            _guideMouse: function (p, r) {
                if (!p) {
                    return
                }
                var q = p.one(".j_HYPScratch");
                var o = q.one(".j_HYPGuideMouse");
                if (!o) {
                    o = f.one('<b class="j_HYPGuideMouse hypGuideMouse"></b>');
                    q.append(o)
                }
                o.css({
                    left: 250,
                    top: 40
                }).show();
                o.stop && o.stop();
                o.animate({
                    left: 110,
                    top: 180
                }, 0.8, "easeNone", function () {
                    r.call()
                })
            },
            _lotteryAnim: function (q) {
                var p = this;
                if (!q) {
                    return
                }
                p._stopLotteryAnim(q);
                var o = f.later(function () {
                    p._scratchAnim(q, l.randomInt(0, 360), "lottery")
                }, p.config.scratchInterval, "lottery");
                q.data("data-scratchTimer", o)
            },
            _stopLotteryAnim: function (q) {
                if (!q) {
                    return
                }
                var o = q.data("data-scratchTimer");
                o && o.cancel();
                q.removeData("data-scratchTimer");
                var r = q.one(".j_HYPScratch");
                var p = r.one(".j_HYPLotteryTip");
                p && p.hide()
            },
            _scratchAnim: function (s, v, r) {
                var p = this;
                if (!s) {
                    return
                }
                var u = s.one(".j_HYPScratch");
                var o = s.data("data-scratchQueue");
                if (!o) {
                    o = []
                }
                var t;
                if (o.length < (e ? 1 : p.config.maxScratch)) {
                    t = f.one('<i class="hypScratchItem"></i>');
                    o.push(t);
                    s.data("data-scratchQueue", o);
                    u.append(t)
                } else {
                    for (var q = 0; q < o.length; q++) {
                        if (!o[q].isRunning()) {
                            t = o[q];
                            break
                        }
                    }
                }
                if (!t) {
                    return
                }
                if (r == "lottery") {
                    p._lotterTip(s);
                    p._shakeItem(s);
                    p._scratchItem(t, v)
                } else {
                    if (r == "guide") {
                        p._scratchItem(t, v, 2, true, e ? 0.01 : 0.4)
                    } else {
                        if (!s.data("data-record")) {
                            l.record("tmallacti.20130618.889?item=" + s.attr("data-it") + "&cache=" + f.now());
                            s.data("data-record", true)
                        }
                        p._inspireTip(s);
                        p._shakeItem(s);
                        p._scratchItem(t, v);
                        p._stopRuleGuideAnim(s)
                    }
                }
            },
            _lotterTip: function (q) {
                var o = this;
                if (!q) {
                    return
                }
                var r = q.one(".j_HYPScratch");
                var p = r.one(".j_HYPLotteryTip");
                if (!p) {
                    p = f.one('<b class="j_HYPLotteryTip hypLotteryTip"></b>');
                    r.append(p)
                }
                p.css({
                    left: 28,
                    top: 28
                }).show();
                p.stop && p.stop();
                p.animate({
                    left: 30,
                    top: 30
                }, 0.5, o._rectangularWave, function () {
                    p.css({
                        left: 32,
                        top: 32
                    })
                })
            },
            _inspireTip: function (x) {
                var y = this;
                if (!x) {
                    return
                }
                var q = x.data("data-ci");
                if (!q) {
                    return
                }
                var t = q.op;
                var v = q.cp;
                var o = q.bp;
                if (o > v || v > t) {
                    return
                }
                var u = 1 - (v - o) / (t - o);
                if (l.randomInt(0, 100) / 100 > y.config.inspireRate) {
                    return
                }
                var w = x.one(".j_HYPScratch");
                var p = w.one(".j_HYPInspire");
                if (!p) {
                    p = f.one('<b class="j_HYPInspire hypInspire"></b>');
                    w.append(p)
                }
                if (p.isRunning()) {
                    return
                }
                var s = l.randomInt(-20, 60);
                var r = l.randomInt(15, 45);
                p.attr("class", "j_HYPInspire hypInspire hypInspire" + parseInt(u * 2) + l.randomInt(0, 2));
                if (e) {
                    p.css({
                        background: "none",
                        filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + y.config.assetsRoot + "image/inspire-" + [parseInt(u * 2)] + "-" + l.randomInt(0, 2) + '.png", sizingMethod="crop"'
                    }).show()
                }
                p.css({
                    top: r,
                    left: s
                }).show();
                p.animate({
                    top: r - 10
                }, 0.3);
                p.fadeOut(0.3)
            },
            _scratchItem: function (t, u, r, s, q) {
                var p = this;
                if (!t) {
                    return
                }
                u = p._mapDegree(u, 15);
                var o = s ? 0 : l.randomInt(-30, 30);
                var v = s ? 0 : l.randomInt(-20, 20);
                if (r == undefined) {
                    r = l.randomInt(0, 2)
                }
                t.attr("class", "hypScratchItem scratchItem" + r + u);
                if (e) {
                    t.css({
                        background: "none",
                        filter: 'progid:DXImageTransform.Microsoft.AlphaImageLoader(src="' + p.config.assetsRoot + "image/" + r + "-" + u + '.png", sizingMethod="crop"'
                    })
                }
                t.css({
                    right: o,
                    top: v,
                    width: 0,
                    height: 0,
                    opacity: 1,
                    display: "block",
                    _filter: "alpha(opacity=100)"
                });
                t.animate({
                    width: 310,
                    height: 250
                }, q || (e ? 0.05 : 0.2), "easeIn", function () {
                    t.fadeOut(0.6)
                })
            },
            _shakeItem: function (q) {
                var p = this;
                if (!q) {
                    return
                }
                var o = q.one(".j_HYPItemLogo");
                if (h.ie < 10) {
                    o.stop && o.stop();
                    o.css("right", 65);
                    o.animate({
                        right: 55
                    }, 0.5, p._rectangularWave, function () {
                        o.css("right", 60)
                    })
                } else {
                    o.addClass("shake");
                    setTimeout(function () {
                        o.removeClass("shake")
                    }, 300)
                }
            },
            _getItem: function (p) {
                var o = this;
                if (!o.hypItems) {
                    return
                }
                return f.one(o.hypItems[p])
            },
            _mapDegree: function (p, o) {
                return (parseInt((p + o / 2) / o) * o) % 360
            },
            _rectangularWave: function (o) {
                if (o === 0 || o === 1) {
                    return o
                }
                if (o > 0 && o < 0.1 || o > 0.2 && o < 0.3 || o > 0.4 && o < 0.5 || o > 0.6 && o < 0.7 || o > 0.8 && o < 0.9) {
                    return -o
                }
                return o
            },
            _formatCountDown: function (o) {
                if (o === 2) {
                    return "\u51c6\u5907"
                }
                if (o === 1) {
                    return "\u5f00\u59cb"
                }
                return o < 10 ? ("0" + o) : o
            },
            _feedbackErr: function (p) {
                var o = this;
                c++;
                console.log("发生系统异常，错误次数为：" + c);
                if (c >= o.config.retryNum) {
                    o._popup("err", {
                        container: p || o.halfYear,
                        type: "err"
                    });
                    c = 0
                }
            },
            _inWhitchItemScratchArea: function (o, s) {
                var r = f.all(".j_HYPScratchArea");
                var q = [{
                    left: r.item(0).offset().left,
                    top: r.item(0).offset().top
                },
                {
                    left: r.item(1).offset().left,
                    top: r.item(1).offset().top
                }];
                var p = {
                    width: r.width(),
                    height: r.height()
                };
                if (o >= q[0].left && o <= q[0].left + p.width && s >= q[0].top && s <= q[0].top + p.height) {
                    return r.item(0)
                } else {
                    if (o >= q[1].left && o <= q[1].left + p.width && s >= q[1].top && s <= q[1].top + p.height) {
                        return r.item(1)
                    } else {
                        return false
                    }
                }
            },
            _getWinnerList: function (p, o) {
                if (!p || p.length < 0) {
                    return ""
                }
                if (p.length <= o) {
                    return p.join("\u3001")
                }
                return p.slice(0, o).join("\u3001") + "\u7b49"
            },
            _secondaryFunc: function () {
                var o = this;
                o._fixSelectstart();
                o._collectData();
                o._resetMiniLogin();
                o._scrollStop();
                o._test()
            },
            _scrollStop: function () {
                var o = this;
                var p = "start";
                f.Event.on(window, "scroll", function () {
                    if (f.DOM.scrollTop() >= 500 && p == "start") {
                        o.modelX.stopLoop();
                        p = "stop"
                    } else {
                        if (f.DOM.scrollTop() < 500 && p == "stop") {
                            o.modelX.startLoop();
                            p = "start"
                        }
                    }
                })
            },
            _fixSelectstart: function () {
                var o = this;
                if (!o.halfYear) {
                    return
                }
                o.halfYear.delegate("selectstart", ".j_HYPItem", function (p) {
                    p.halt()
                })
            },
            _collectData: function () {
                var o = this;
                if (!o.halfYear) {
                    return
                }
                o.halfYear.delegate("click", ".j_HYPCollect", function (q) {
                    var p = f.one(q.currentTarget);
                    f.later(function () {
                        l.record(p.attr("data-code") + "&cache=" + f.now())
                    }, 100)
                })
            },
            _resetMiniLogin: function () {
                var o = this;
                if (!o.halfYear) {
                    return
                }
                f.one("body").delegate("click", "#TML_Login_MLogin_Close", function () {
                    d = false
                })
            },
            _test: function () {
                var o = this
            }
        });
        return a
    }, {
        requires: ["dom", "event", "node", "anim", "cookie", "ua", "./utilX"]
    }); /*pub-1|2013-06-17 01:42:13*/
    KISSY.add("main/ua-helperX", function (b) {
        window.ua = "";
        window.UA_Opt = new Object();
        var a = {
            load: function () {
                var c = this;
                UA_Opt.LogVal = "ua";
                UA_Opt.MaxMCLog = 3;
                UA_Opt.MaxMPLog = 3;
                UA_Opt.MaxKSLog = 3;
                UA_Opt.SendMethod = 8;
                UA_Opt.MPInterval = 28;
                UA_Opt.Flag = 81806;
                b.getScript("http://uaction.aliyuncdn.com/js/ua.js", function () {
                    c.fire("loaded")
                })
            },
            getUAToken: function () {
                var c = this;
                var d = window.ua;
                c._reloadUA();
                return d
            },
            _reloadUA: function () {
                UA_Opt.Token = new Date().getTime() + ":" + Math.random();
                UA_Opt.reload && UA_Opt.reload()
            }
        };
        b.mix(a, b.EventTarget);
        a.load();
        return a
    }, {
        requires: ["event"]
    }); /*pub-1|2013-06-17 01:42:15*/
    KISSY.add("main/utilX", function (b) {
        var c = b.unparam(document.location.search.substring(1));
        var a = window.mmstat = new Image();
        var d = {
            locationToDegree: function (e, f) {
                return (Math.atan2(e, f) / (Math.PI * 2) * 360 + 360) % 360
            },
            randomInt: function (f, e) {
                return Math.round(Math.random() * (e - f)) + f
            },
            record: function (e) {
                if (!e) {
                    return
                }
                a.src = "http://log.mmstat.com/" + e
            },
            log: function () {
                //if (c.debug != "true") {
                //    return
                //}
                for (var e = 0; e < arguments.length; e++) {
                    if (!arguments[e]) {
                        continue
                    }
                    console && console.log(arguments[e])
                }
            }
        };
        return d
    });

    var ff = function () {
        KISSY.use('main/hypX', function (S, q) {
            new arguments[arguments.length - 1]({
                assetsRoot: 'http://a.tbcdn.cn/apps/tmall/fp/2012/act/halfyear/1.0.1/main/'
            });
            var o = this;
        });
    };

    setTimeout(ff, 1000);


}, true);


